<?php
namespace Bushelpowered\Api\Platform\Message\V1;

use \Bushelpowered\Api\Platform\Message\V1\Request\SendMessageRequest;
use \Bushelpowered\Api\Common\Response\UUIDResponse;
use \Bushelpowered\Api\Common\BadRequest;
use \Bushelpowered\Api\Common\ConstraintViolation;
use \Bidl\Php\Core\Builtins\UnknownError;

class SendMessageOperation 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(SendMessageRequest $request, $headers): UUIDResponse | BadRequest | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/platform/message/v1/SendMessageOperation', $request, $this->getWrapper(), $headers);
    }
    
    public function request(SendMessageRequest $request, SendMessageOperationMetadata $hasHeaders): UUIDResponse | BadRequest | ConstraintViolation | UnknownError
    {
         return $this->client->call('api/platform/message/v1/SendMessageOperation', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var UUIDResponse | BadRequest | ConstraintViolation | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.platform.message.v1#SendMessageOperationSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\Response\UUIDResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#BadRequest':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\BadRequest::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#ConstraintViolation':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\ConstraintViolation::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}